%define enable_xcb 1
%define subrel 1
# mklibname should handle the special cases of library naming
%define libx11 %mklibname x11_ 6
%define libxorgoldname %mklibname xorg-x11
%define libxcb %mklibname xcb 1
Name: libx11
Summary: X Library
Version: 1.2.1
Release: %mkrel 1
Group: System/Libraries
License: MIT
URL: http://xorg.freedesktop.org
Source0: http://xorg.freedesktop.org/releases/individual/lib/libX11-%{version}.tar.bz2

# (cg) I've disabled this local copy for now... let's see how it goes :)
# the new default unicode compose file is too human-unfriendly; keeping
# the old one...
Source10: X_Compose-en_US.UTF-8
# locale.dir, compose.dir, locale.alias files.
# maintaining them trough patches is a nightmare, as they change
# too much too often; it is easier to manage them separately -- pablo
Source11: X11-compose.dir
Source12: X11-locale.alias
Source13: X11-locale.dir
BuildRoot: %{_tmppath}/%{name}-root
Obsoletes: libxorg-x11
Provides: libxorg-x11

BuildRequires: x11-util-macros		>= 1.1.5
BuildRequires: x11-xtrans-devel		>= 1.0.4
BuildRequires: libxdmcp-devel		>= 1.0.2
BuildRequires: libxau-devel		>= 1.0.3
BuildRequires: x11-proto-devel		>= 7.3

# because of %{_datadir/X11} being owned by x11-server-common
Requires(pre): x11-server-common >= 1.4.0.90-13mdv

%if %{enable_xcb}
BuildRequires: xcb-devel
%endif

%description
%{name} contains the shared libraries that most X programs
need to run properly. These shared libraries are in a separate package in
order to reduce the disk space needed to run X applications on a machine
without an X server (i.e, over a network).

#-----------------------------------------------------------

%package -n %{libx11}
Summary: X Library
Group: Development/X11
Conflicts: %{libxorgoldname} < 7.0
Provides: %{name} = %{version}
Requires(post): grep
Requires(postun): grep coreutils
%if %{enable_xcb}
Requires: %libxcb >= 1.2
%endif

%description -n %{libx11}
%{name} contains the shared libraries that most X programs
need to run properly. These shared libraries are in a separate package in
order to reduce the disk space needed to run X applications on a machine
without an X server (i.e, over a network).

%post -n %{libx11}
if  grep -q "^%{_prefix}/X11R6/lib$" /etc/ld.so.conf; then
    grep -v "^%{_prefix}/X11R6/lib$" /etc/ld.so.conf > /etc/ld.so.conf.new
    mv -f /etc/ld.so.conf.new /etc/ld.so.conf
    /sbin/ldconfig
fi

%postun -n %{libx11}
if [ "$1" = "0" \
   -a "`grep "^%{_prefix}/X11R6/lib$" /etc/ld.so.conf`" != "" ]; then
    grep -v "^%{_prefix}/X11R6/lib$" /etc/ld.so.conf > /etc/ld.so.conf.new
    mv -f /etc/ld.so.conf.new /etc/ld.so.conf
    /sbin/ldconfig
fi

#-----------------------------------------------------------

%package -n %{libx11}-devel
Summary: Development files for %{name}
Group: Development/X11
Requires: %{libx11} = %{version}
Requires: x11-proto-devel >= 1.0.0
Provides: libx11-devel = %{version}-%{release}
Conflicts: %{libxorgoldname}-devel < 7.0

%description -n %{libx11}-devel
%{name} includes the libraries, header files and documentation
you'll need to develop programs which run in X clients. X11 includes
the base Xlib library as well as the Xt and Xaw widget sets.

For guidance on programming with these libraries, O'Reilly & Associates
produces a series on X programming which you might find useful.

Install %{name} if you are going to develop programs which
will run as X clients.

%pre -n %{libx11}-devel
if [ -h %{_includedir}/X11 ]; then
	rm -f %{_includedir}/X11
fi

%files -n %{libx11}-devel
%defattr(-,root,root)
%{_mandir}/man3/*.3.*
%{_libdir}/libX11.so
%{_libdir}/libX11.la
%{_libdir}/pkgconfig/x11.pc
%{_includedir}/X11/cursorfont.h
%{_includedir}/X11/ImUtil.h
%{_includedir}/X11/Xlocale.h
%{_includedir}/X11/Xcms.h
%{_includedir}/X11/Xlibint.h
%{_includedir}/X11/Xlib.h
%{_includedir}/X11/Xresource.h
%{_includedir}/X11/Xregion.h
%{_includedir}/X11/Xutil.h
%{_includedir}/X11/XlibConf.h
%{_includedir}/X11/XKBlib.h
%if %enable_xcb
%{_libdir}/libX11-xcb.so
%{_libdir}/libX11-xcb.la
%{_libdir}/pkgconfig/x11-xcb.pc
%{_includedir}/X11/Xlib-xcb.h
%endif

#-----------------------------------------------------------

%package -n %{libx11}-static-devel
Summary: Static development files for %{name}
Group: Development/X11
Requires: %{libx11}-devel = %{version}
Conflicts: %{libxorgoldname}-static-devel < 7.0
Provides: libx11-static-devel = %{version}-%{release}

%description -n %{libx11}-static-devel
Static development files for %{name}

%files -n %{libx11}-static-devel
%defattr(-,root,root)
%{_libdir}/libX11.a
%if %enable_xcb
%{_libdir}/libX11-xcb.a
%endif

#-----------------------------------------------------------

%package common
Summary: Common files used by the X.org
Group: System/X11

%description common
Common files used by the X.org

%files common
%defattr(-,root,root)
%dir %{_datadir}/X11/locale
%{_datadir}/X11/locale/*
%{_libdir}/X11/Xcms.txt
%{_datadir}/X11/XErrorDB
%{_datadir}/X11/XKeysymDB

#-----------------------------------------------------------

%prep
%setup -q -n libX11-%{version}

# backup the original files (so we can look at them later) and use our own

# (cg) The Upstream Compose.pre looks good now, so let's try it out :)
#cp nls/en_US.UTF-8/Compose.pre nls/en_US.UTF-8/Compose.orig
#cat %{SOURCE10} | sed 's/#/XCOMM/' > nls/en_US.UTF-8/Compose.pre

cp nls/compose.dir.pre nls/compose.dir.orig
cat %{SOURCE11} | sed 's/#/XCOMM/' > nls/compose.dir.pre

cp nls/locale.alias.pre nls/locale.alias.orig
cat %{SOURCE12} | sed 's/#/XCOMM/' > nls/locale.alias.pre

cp nls/locale.dir.pre nls/locale.dir.orig
cat %{SOURCE13} | sed 's/#/XCOMM/' > nls/locale.dir.pre


%build
CFLAGS="-O0 -g3" \
%configure2_5x \
		%if %enable_xcb
		--with-xcb
		%else
		--without-xcb
		%endif

%make

%install
rm -rf %{buildroot}
%makeinstall_std

%clean
rm -rf %{buildroot}

%if %mdkversion < 200900
%post -p /sbin/ldconfig
%endif
%if %mdkversion < 200900
%postun -p /sbin/ldconfig
%endif

%files -n %{libx11}
%defattr(-,root,root)
%{_libdir}/libX11.so.6
%{_libdir}/libX11.so.6.2.0
%if %enable_xcb
%{_libdir}/libX11-xcb.so.1
%{_libdir}/libX11-xcb.so.1.0.0
%endif


%changelog
* Tue Jun 09 2009 Ander Conselvan de Oliveira <ander@mandriva.com> 1.2.1-1.1mdv2009.1
+ Revision: 384416
- Explicitly require libxcb1 1.2 or later.

* Wed Apr 08 2009 Ander Conselvan de Oliveira <ander@mandriva.com> 1.2.1-1mdv2009.1
+ Revision: 365222
- New version 1.2.1

* Tue Feb 17 2009 Colin Guthrie <cguthrie@mandriva.org> 1.2-1mdv2009.1
+ Revision: 342130
- New version: 1.2
- Try the upstream Compose.pre file (commit log says it's nicer now)

* Wed Feb 04 2009 Ander Conselvan de Oliveira <ander@mandriva.com> 1.1.99.2-4mdv2009.1
+ Revision: 337438
- Fix bug that caused hangs in applications such as Ekiga and OpenOffice(#45751)

* Thu Nov 06 2008 Colin Guthrie <cguthrie@mandriva.org> 1.1.99.2-3mdv2009.1
+ Revision: 300304
- Rebuild due to random failure on i586
- New version: 1.1.99.2 (rc)
- This uses the new libxcb socket handoff mechanism

  + Olivier Blin <oblin@mandriva.com>
    - rebuild with xcb
    - build temporarily without xcb

* Fri Sep 05 2008 Thierry Vignaud <tvignaud@mandriva.com> 1.1.5-1mdv2009.0
+ Revision: 281261
- fix xcb-devel BuildRequires
- new release
- remove merged patches
- fix group

* Thu Aug 07 2008 Ander Conselvan de Oliveira <ander@mandriva.com> 1.1.4-5mdv2009.0
+ Revision: 266990
- Fix quoting issue in postun scriptlet (bug #42569)

* Wed Aug 06 2008 Thierry Vignaud <tvignaud@mandriva.com> 1.1.4-4mdv2009.0
+ Revision: 264937
- rebuild early 2009.0 package (before pixel changes)

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Mon May 26 2008 Paulo Andrade <pcpa@mandriva.com.br> 1.1.4-3mdv2009.0
+ Revision: 211452
- o Cherry pick some commits added after libX11-1.1.4 tag
  o Don't add /usr/X11R6/lib to ld.so.conf in %%post, and now, also remove
  it in %%pre as it causes problems with recent changes to make /usr/X11R6
  a symlink to /usr.

* Mon May 05 2008 Paulo Andrade <pcpa@mandriva.com.br> 1.1.4-2mdv2009.0
+ Revision: 201575
- Change ownership of %%{_datadir}/X11 to x11-server-common package.

* Mon Apr 14 2008 Paulo Andrade <pcpa@mandriva.com.br> 1.1.4-1mdv2009.0
+ Revision: 192981
- Update to version 1.1.4.

* Mon Mar 31 2008 Anssi Hannula <anssi@mandriva.org> 1.1.3-6mdv2008.1
+ Revision: 191311
- move the script requires added in last release to binary package

* Sat Mar 01 2008 Olivier Blin <oblin@mandriva.com> 1.1.3-5mdv2008.1
+ Revision: 176984
- require grep in post script (and coreutils in postun)

* Fri Feb 08 2008 Paulo Andrade <pcpa@mandriva.com.br> 1.1.3-4mdv2008.1
+ Revision: 164304
- Enable xcb in libx11 build.
  Note that the real libX11.so changes are minimal, and to actually
  use xcb, it is required to explicitly link with libX11-xcb.so, and
  it should be better to also use xcb-devel headers (but there should
  not exist any binary incompatibility).
  One could also try the luck with a command like:
  LD_PRELOAD=/usr/lib/libX11-xcb.so run-some-program

* Mon Jan 14 2008 Paulo Andrade <pcpa@mandriva.com.br> 1.1.3-3mdv2008.1
+ Revision: 151524
- Update BuildRequires and rebuild.

  + Thierry Vignaud <tvignaud@mandriva.com>
    - rebuild
    - kill re-definition of %%buildroot on Pixel's request

  + Colin Guthrie <cguthrie@mandriva.org>
    - Conditionally include files from XCB enable build.

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

* Fri Sep 28 2007 Frederic Crozat <fcrozat@mandriva.com> 1.1.3-2mdv2008.0
+ Revision: 93530
- Patch0 (GIT): add missing keys to XKeysymDB (Mdv bug #34247)

* Fri Aug 03 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 1.1.3-1mdv2008.0
+ Revision: 58399
- drop patch 0 (merged upstream)
- new upstream version 1.1.3

  + Ademar de Souza Reis Jr <ademar@mandriva.com.br>
    - add missing libxcb build-requirement
    - build section cleanup

* Sun Jun 10 2007 Olivier Blin <oblin@mandriva.com> 1.1.2-2mdv2008.0
+ Revision: 37943
- fix XGetMotionEvents prototype (should fix gimp paintbrush, submitted as upstream bug #11222)
- use -a option for automake and run autoheader (to ease building from git)

* Mon Jun 04 2007 Ademar de Souza Reis Jr <ademar@mandriva.com.br> 1.1.2-1mdv2008.0
+ Revision: 35178
- new upstream version: 1.1.2
- remove patch already applied (CVE-2007-1667)

* Thu May 03 2007 Ademar de Souza Reis Jr <ademar@mandriva.com.br> 1.1.1-3mdv2008.0
+ Revision: 22005
- add patch for CVE-2007-1667 (see #29818 comments)


* Sun Feb 18 2007 Götz Waschk <waschk@mandriva.org> 1.1.1-2mdv2007.0
+ Revision: 122277
- rebuild for pkgconfig deps

* Fri Feb 09 2007 Gustavo Pichorim Boiko <boiko@mandriva.com> 1.1.1-1mdv2007.1
+ Revision: 118504
- new upstream release: 1.1.1

  + Pablo Saratxaga <pablo@mandriva.com>
    - merged {compose,locale}.dir with X11.org files
    - zh_HK.UTF-
    - added recognition of more locales (now in sync with DrakX)

* Thu Nov 16 2006 Pablo Saratxaga <pablo@mandriva.com> 1.0.3-3mdv2007.1
+ Revision: 84844
- improved default UTF-8 Compose file
- improved {locale,compose}.{dir,alias} with definitions for all our locales

* Fri Jul 07 2006 Gustavo Pichorim Boiko <boiko@mandriva.com> 1.0.3-2mdv2007.0
+ Revision: 38413
- Removed wrong requires for mkcomposecache. Thanks for Stefan van der Eijk for pointing that.

  + Thierry Vignaud <tvignaud@mandriva.com>
    - fix group

* Tue Jul 04 2006 Gustavo Pichorim Boiko <boiko@mandriva.com> 1.0.3-1mdv2007.0
+ Revision: 38293
- new upstream release (1.0.3):
  * Fix Compose Cache
  * One instance of checking the setuid() return value was missed

* Thu Jun 29 2006 Gustavo Pichorim Boiko <boiko@mandriva.com> 1.0.2-1mdv2007.0
+ Revision: 38132
- new upstream release (1.0.2). Highlights:
  * i18n: Separate data and lib directories
  * Break out locale data into separate data and library directories, under
  $(datadir) and $(libdir), respectively, by default.
  * im: add Braille input method (#6296)
  * fdo bug #3104: Compose table cache for faster X11 application starts.
  * Set XTHREADLIB correctly for dragonfly platforms.
  * Fix threading support on GNU/kFreeBSD systems.
  * Check setuid() return value
- removed patch for braille support (this release already has that)
- rebuild to fix cooker uploading
- renamed libx11_6-common to libx11-common
- increment release
- fixed more dependencies
- Adding X.org 7.0 to the repository

  + Frederic Crozat <fcrozat@mandriva.com>
    - Release 1.0.1
      Patch0 (GIT): add braille input method support

  + Andreas Hasenack <andreas@mandriva.com>
    - renamed mdv to packages because mdv is too generic and it's hosting only packages anyway

  + Laurent Montel <lmontel@mandriva.com>
    - Fix conflict on x86_64

  + Thierry Vignaud <tvignaud@mandriva.com>
    - provides/obsoletes libxorg-x11 (so that updates work smoothly)

